		BITS	32
		CPU	386

		section	.text
		org	0x40000000




_load:		db	0x7F,0x45,0x4C,0x46	; 0
		db	0x01,0x01,0x01,0x03	; 4

%ifdef	USE_HEADER
getchar:	db	0x60,0x6a,0x03,0x58	; 8
		db	0x31,0xdb,0xeb,0x10	; 16
%else
		db	0x00,0x00,0x00,0x00
		db	0x00,0x00,0x00,0x00
%endif

		db	0x02,0x00,0x03,0x00	; 20
		db	0x01,0x00,0x00,0x00	; 24
		dd	_start			; 28
		db	0x34,0x00,0x00,0x00	; 32

%ifdef	USE_HEADER
		db	0x8d,0x4c,0x24,0x1c	; 36
		db	0x6a,0x01,0x5a,0xeb
		db	0x27,0x90
%else
		db	0x00,0x00,0x00,0x00
		db	0x00,0x00,0x00,0x00
		db	0x34,0x00
%endif		
		db	0x20,0x00,0x01,0x00
%ifdef	USE_HEADER
exit:
		db	0xb0,0x01,0x31,0xdb,0xcd,0x80
%else
		db	0x28,0x00,0x00,0x00,0x00,0x00
%endif		
; PROGRAM HEADER
		db	0x01,0x00,0x00,0x00	;type
		db	0x00,0x00,0x00,0x00	;offset
		dd	_load, _load		;va,pa
		db	0x00,0x00,0x00,0x00	;fs
		db	0x00,0x00,0x00,0x00	;ms
%ifdef	USE_HEADER
		db	0x06,0x00,0x00,0x00
c3:		db	0xcd,0x80,0x61,0xc3
%else
		db	0x06,0x00,0x00,0x00	;flags
		db	0x00,0x00,0x00,0x00	;align
%endif

%macro movb 2 
	%if %2 == 0
		xor     %1, %1
	%else
		push    byte %2
		pop     %1
	%endif
%endmacro

%ifndef	USE_HEADER
getchar:	pusha
		movb	eax, 3
		movb	ebx, 0
		lea	ecx, [esp + 28]
		movb	edx, 1
		int	0x80
		popa
		ret
exit:		mov	al, 1
		movb	ebx, 0
		int	0x80
%endif
putchar:	pusha
		movb	eax, 4
		movb	ebx, 1
		lea	ecx, [esp + 36]
		mov	edx, ebx
		int	0x80
		mov	[esp + 28], eax
		popa
		ret

_start:		lea	esi, [program]
		cld
		cmp	word [esi], 0x4642
		jne	exit
		movzx	ecx, word [esi + 2]
		inc	ecx
		lodsd
		sub	esp, ecx
		mov	edi, esp
		mov	edx, edi
		sub	esp, 30000
		mov	ebp, esp		
		xor	ebx, ebx
.decode:	push	ecx
		movb	eax, 0
		movb	ecx, 3
.char:		bt	[esi], ebx
		rcl	eax, 1
		inc	ebx
		loop	.char
; [0 .. 7] -> [43 .. 46 60 62 91 93]
		add	al, 43
		cmp	al, 46
		jbe	.stos
.l60:		add	al, 43
		jnp	.stos
		sub	al, 30
.stos:		stosb
		pop	ecx
		loop	.decode
		movb	eax, 0
		stosb

		push	putchar
		push	getchar
		push	ebp
		push	edx
		push	exit

bfi:		incbin	'../bfi.bin'
program:

;EOF
